VST 3 SDK: Steinberg::Vst Namespace Reference
Author: Steinberg

VST 3 SDK VST 3.7 SDK for developing VST plug-in

Namespaces | Classes | Typedefs | Enumerations | Functions | Variables
Steinberg::Vst Namespace Reference

## Namespaces
namespace | Algo
namespace | Attributes
namespace | AttributesFlags
namespace | AttributesFunction
namespace | AttributesStyle
namespace | ChannelContext
namespace | CurveType
namespace | FunctionNameType
namespace | Helpers
namespace | InterAppAudio
namespace | LayerType
namespace | MPE
namespace | MusicalCharacter
namespace | MusicalInstrument
namespace | MusicalStyle
namespace | PlugType
namespace | PresetAttributes
namespace | SampleAccurate
namespace | SpeakerArr
namespace | StateType
namespace | StringConvert
namespace | Test
namespace | UMP
namespace | ViewType

## Classes
class | AudioBuffer
class | AudioBus
| Description of an Audio Bus. More...
struct | AudioBusBuffers
class | AudioEffect
| Default implementation for a VST 3 audio effect. More...
class | BufferStream
| Stream implementation for a memory buffer. More...
class | Bus
| Basic Bus object. More...
struct | BusInfo
class | BusList
| List of Busses. More...
class | BypassProcessor
struct | Chord
struct | ChordEvent
class | Component
| Default implementation for a VST 3 Component. More...
class | ComponentBase
| Base class for VST 3 Component and Edit Controller. More...
class | ConnectionProxy
| Helper for creating and initializing component. More...
struct | DataEvent
struct | DataExchangeBlock
class | DataExchangeHandler
| Helper class to provide a single API for plug-ins to transfer data from the realtime audio process to the edit controller either via the backwards compatible message handling protocol (see IMessage) or the new IDataExchangeHandler/IDataExchangeReceiver API. More...
class | DataExchangeReceiverHandler
| Helper class to provide a single API for plug-ins to transfer data from the realtime audio process to the edit controller either via the message handling protocol (see IMessage) or the new IDataExchangeHandler/IDataExchangeReceiver API. More...
class | EditController
| Default implementation for a VST 3 edit controller. More...
class | EditControllerEx1
| Advanced implementation (support IUnitInfo) for a VST 3 edit controller. More...
class | EditorView
| View related to an edit controller. More...
struct | Event
class | EventBus
| Description of an Event Bus. More...
class | EventList
| Example implementation of IEventList. More...
class | FileStream
| Stream implementation for a file using stdio. More...
struct | FrameRate
class | HostApplication
| Implementation's example of IHostApplication. More...
class | HostAttributeList
| Example, ready to use implementation of IAttributeList. More...
struct | HostDataExchangeHandler
class | HostMessage
| Example implementation of IMessage. More...
class | HostProcessData
| Extension of ProcessData. More...
class | IAttributeList
class | IAudioPresentationLatency
class | IAudioProcessor
class | IAutomationState
class | IComponent
class | IComponentHandler
class | IComponentHandler2
class | IComponentHandler3
class | IComponentHandlerBusActivation
class | IComponentHandlerSystemTime
class | IConnectionPoint
class | IContextMenu
struct | IContextMenuItem
class | IContextMenuTarget
class | IDataExchangeHandler
struct | IDataExchangeHandlerHost
class | IDataExchangeReceiver
class | IEditController
class | IEditController2
class | IEditControllerHostEditing
class | IEventList
class | IHostApplication
class | IInterAppAudioConnectionNotification
class | IInterAppAudioHost
class | IInterAppAudioPresetManager
class | IKeyswitchController
class | IMessage
class | IMidiLearn
class | IMidiMapping
class | INoteExpressionController
class | INoteExpressionPhysicalUIMapping
class | IParameterChanges
class | IParameterFinder
class | IParameterFunctionName
class | IParamValueQueue
class | IPlugInterfaceSupport
class | IPrefetchableSupport
class | IProcessContextRequirements
class | IProgramListData
class | IProgress
class | IRemapParamID
class | IStreamAttributes
class | ITestPlugProvider
class | ITestPlugProvider2
class | IUnitData
class | IUnitHandler
class | IUnitHandler2
class | IUnitInfo
class | IVst3ToAAXWrapper
class | IVst3ToAUWrapper
class | IVst3ToVst2Wrapper
class | IVst3WrapperMPESupport
class | IXmlRepresentationController
struct | KeyswitchInfo
struct | LegacyMIDICCOutEvent
struct | NoteExpressionTextEvent
class | NoteExpressionType
| Note expression type object. More...
class | NoteExpressionTypeContainer
| Collection of note expression types. More...
struct | NoteExpressionTypeInfo
struct | NoteExpressionValueDescription
struct | NoteExpressionValueEvent
struct | NoteOffEvent
struct | NoteOnEvent
class | ParamChanges
| AutomationTest helper classes: implementation of IParamValueQueue. More...
class | Parameter
| Description of a Parameter. More...
class | ParameterChanges
| Implementation's example of IParameterChanges - not threadsave!. More...
class | ParameterChangeTransfer
| Ring buffer for transferring parameter changes from a writer to a read thread . More...
class | ParameterContainer
| Collection of parameters. More...
struct | ParameterInfo
class | ParameterValueQueue
| Implementation's example of IParamValueQueue - not threadsave!. More...
class | ParamPoint
| AutomationTest helper classes. More...
struct | PhysicalUIMap
struct | PhysicalUIMapList
class | PluginContextFactory
class | PlugInterfaceSupport
| Example implementation of IPlugInterfaceSupport. More...
class | PlugProvider
| Helper for creating and initializing component. More...
struct | PolyPressureEvent
class | PresetFile
| Handler for a VST 3 Preset File. More...
struct | ProcessContext
class | ProcessContextRequirements
struct | ProcessData
class | ProcessDataSlicer
| Process Data Slicer. More...
struct | ProcessSetup
class | ProgramList
| ProgramList element. More...
struct | ProgramListInfo
class | ProgramListWithPitchNames
| ProgramListWithPitchNames element. More...
class | RangeNoteExpressionType
| Note expression type object representing a custom range. More...
class | RangeParameter
| Description of a RangeParameter. More...
class | ReadOnlyBStream
| Stream representing a Read-Only subsection of its source stream. More...
struct | RepresentationInfo
struct | RoutingInfo
struct | RTTransferT
| Transfer objects from a non realtime thread to a realtime one. More...
struct | ScaleEvent
class | SingleComponentEffect
| Default implementation for a non-distributable Plug-in that combines processor and edit controller in one component. More...
class | SpeakerArray
| Helper class representing speaker arrangement as array of speaker types. More...
class | StringListParameter
| Description of a StringListParameter. More...
class | StringResult
class | SystemTime
| SystemTime Helper class. More...
class | TestBase
| Test Helper. More...
struct | TestDefaults
class | TestEnh
| Test Helper. More...
struct | TestingPluginContext
class | ThreadChecker
class | Unit
| Unit element. More...
struct | UnitInfo
class | VSTGUIEditor
| Base class for an edit view using VSTGUI. More...
class | XmlRepresentationHelper
| Helper for XML Representation creation. More...

## Typedefs
typedef uint32 | DataExchangeQueueID
typedef uint32 | DataExchangeBlockID
typedef uint32 | DataExchangeUserContextID
typedef int32 | KnobMode
typedef uint32 | NoteExpressionTypeID
typedef double | NoteExpressionValue
typedef uint32 | KeyswitchTypeID
typedef uint32 | PhysicalUITypeID
typedef uint32 | PrefetchableSupport
typedef char16 | TChar
typedef TChar | String128[128]
typedef const char8 * | CString
typedef int32 | MediaType
typedef int32 | BusDirection
typedef int32 | BusType
typedef int32 | IoMode
typedef int32 | UnitID
typedef double | ParamValue
typedef uint32 | ParamID
typedef int32 | ProgramListID
typedef int16 | CtrlNumber
typedef double | TQuarterNotes
typedef int64 | TSamples
typedef uint32 | ColorSpec
typedef float | Sample32
typedef double | Sample64
typedef double | SampleRate
typedef uint64 | SpeakerArrangement
typedef uint64 | Speaker
using | ChunkID = char[4]
using | ProcessSampleSize = int32
using | TestFunc = std::function< bool(ITestResult *)>
| simple test function More...
using | TestFuncWithContext = std::function< bool(FUnknown *, ITestResult *)>
| test function with context pointer More...

## Enumerations
enum | ComponentFlags
enum | SymbolicSampleSizes
enum | ProcessModes
enum | MediaTypes
enum | BusDirections
enum | BusTypes
enum | IoModes
enum | RestartFlags
enum | KnobModes
enum | NoteIDUserRange
enum | ControllerNumbers
enum | NoteExpressionTypeIDs
enum | KeyswitchTypeIDs
enum | PhysicalUITypeIDs
enum | ePrefetchableSupport
enum | ChunkType { kHeader , kComponentState , kControllerState , kProgramData , kMetaInfo , kChunkList , kNumPresetChunks }

## Functions
IMessage * | allocateMessage (IHostApplication *host)
void ** | getChannelBuffersPointer (const ProcessSetup &processSetup, const AudioBusBuffers &bufs)
| Returns the current channelBuffers used (depending of symbolicSampleSize). More...
uint32 | getSampleFramesSizeInBytes (const ProcessSetup &processSetup, int32 numSamples)
| Returns the size in bytes of numSamples for one channel depending of symbolicSampleSize. More...
uint64 | getChannelMask (int32 numChannels)
| return the bit-mask of channels for the given number of channel for example: numChannels = 1 => 0b0001 (binar) = 0x01 = 1 (decimal) numChannels = 2 => 0b0011 (binar) = 0x03 = 3 (decimal) numChannels = 6 => 0b0011 1111 (binar) = 0x3F = 63 (decimal) More...
tresult | getSpeakerChannelIndex (SpeakerArrangement arrangement, uint64 speaker, int32 &channel)
| Gets the channel index of a given speaker in a arrangement, returns kResultFalse if speaker not part of the arrangement else returns kResultTrue. More...
void | setupVSTGUIBundleSupport (void *hInstance)
const ChunkID & | getChunkID (ChunkType type)
bool | verify (tresult result)
bool | copyStream (IBStream *inStream, IBStream *outStream)
| IMPLEMENT_FUNKNOWN_METHODS (FileStream, IBStream, IBStream::iid) tresult FileStream
| IMPLEMENT_REFCOUNT (ReadOnlyBStream) ReadOnlyBStream
| IMPLEMENT_FUNKNOWN_METHODS (BufferStream, IBStream, IBStream::iid) BufferStream
bool | isEqualID (const ChunkID id1, const ChunkID id2)
| IMPLEMENT_FUNKNOWN_METHODS (ConnectionProxy, IConnectionPoint, IConnectionPoint::iid) ConnectionProxy
| IMPLEMENT_FUNKNOWN_METHODS (EventList, IEventList, IEventList::iid) EventList
| IMPLEMENT_FUNKNOWN_METHODS (HostMessage, IMessage, IMessage::iid) HostMessage
| IMPLEMENT_FUNKNOWN_METHODS (HostAttributeList, IAttributeList, IAttributeList::iid) IPtr< IAttributeList > HostAttributeList
| IMPLEMENT_FUNKNOWN_METHODS (ParameterChanges, IParameterChanges, IParameterChanges::iid) IMPLEMENT_FUNKNOWN_METHODS(ParameterValueQueue
| IMPLEMENT_FUNKNOWN_METHODS (TestBase, ITest, ITest::iid)
void | addMessage (ITestResult *testResult, const std::u16string &str)
void | addMessage (ITestResult *testResult, const char *str)
void | addErrorMessage (ITestResult *testResult, const char *str)
void | addErrorMessage (ITestResult *testResult, const std::u16string &str)
std::u16string | printf (const char8 *format,...)
| IMPLEMENT_FUNKNOWN_METHODS (ParamChanges, IParamValueQueue, IParamValueQueue::iid) ParamChanges
| SMTG_TYPE_ALIGN_CHECK (PFactoryInfo, 4, 4, 4, 4) SMTG_TYPE_ALIGN_CHECK(PClassInfo
| SMTG_TYPE_ALIGN_CHECK (PClassInfo2, 4, 4, 4, 4) SMTG_TYPE_ALIGN_CHECK(PClassInfoW
| SMTG_TYPE_ALIGN_CHECK (ProcessSetup, 8, 1, 8, 8) SMTG_TYPE_ALIGN_CHECK(AudioBusBuffers
| SMTG_TYPE_ALIGN_CHECK (ProcessData, 8, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(BusInfo
| SMTG_TYPE_ALIGN_CHECK (RoutingInfo, 4, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(IContextMenuItem
| SMTG_TYPE_ALIGN_CHECK (ParameterInfo, 8, 1, 8, 8) SMTG_TYPE_ALIGN_CHECK(NoteOnEvent
| SMTG_TYPE_ALIGN_CHECK (NoteOffEvent, 4, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(DataEvent
| SMTG_TYPE_ALIGN_CHECK (PolyPressureEvent, 4, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(ChordEvent
| SMTG_TYPE_ALIGN_CHECK (ScaleEvent, 8, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(LegacyMIDICCOutEvent
| SMTG_TYPE_ALIGN_CHECK (Event, 8, 1, 8, 8) SMTG_TYPE_ALIGN_CHECK(NoteExpressionValueDescription
| SMTG_TYPE_ALIGN_CHECK (NoteExpressionValueEvent, 8, 1, 4, 8) SMTG_TYPE_ALIGN_CHECK(NoteExpressionTextEvent
| SMTG_TYPE_ALIGN_CHECK (NoteExpressionTypeInfo, 8, 1, 8, 8) SMTG_TYPE_ALIGN_CHECK(KeyswitchInfo
| SMTG_TYPE_ALIGN_CHECK (FrameRate, 4, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(Chord
| SMTG_TYPE_ALIGN_CHECK (ProcessContext, 8, 1, 8, 8) SMTG_TYPE_ALIGN_CHECK(RepresentationInfo
| SMTG_TYPE_ALIGN_CHECK (UnitInfo, 4, 1, 4, 4) SMTG_TYPE_ALIGN_CHECK(ProgramListInfo
void | printStructSizes ()
void * | aligned_alloc (size_t numBytes, uint32_t alignment)
| aligned allocation More...
void | aligned_free (void *addr, uint32_t alignment)
template<SymbolicSampleSizes SampleSize, typename std::enable_if< SampleSize==SymbolicSampleSizes::kSample32 >::type * = nullptr>
Sample32 ** | getChannelBuffers (AudioBusBuffers &buffer)
| get channel buffers from audio bus buffers 32 bit variant More...
template<SymbolicSampleSizes SampleSize, typename std::enable_if< SampleSize==SymbolicSampleSizes::kSample64 >::type * = nullptr>
Sample64 ** | getChannelBuffers (AudioBusBuffers &buffer)
| get channel buffers from audio bus buffers 64 bit variant More...
bool | operator== (const DataExchangeHandler::Config &c1, const DataExchangeHandler::Config &c2)
bool | operator!= (const DataExchangeBlock &lhs, const DataExchangeBlock &rhs)
bool | operator== (const DataExchangeBlock &lhs, const DataExchangeBlock &rhs)
const Steinberg::Vst::TChar * | toTChar (const std::u16string &str)
template<typename NumberT >
std::u16string | toString (NumberT value)
| convert a number to an UTF-16 string More...
FUnknown * | createTestFactoryInstance (void *)
| create a Test Factory instance More...
const FUID & | getTestFactoryUID ()
| get the test factory class ID More...
void | registerTest (FIDString name, const char *desc, const TestFunc &func)
| register a simple test function More...
void | registerTest (FIDString name, const char *desc, TestFunc &&func)
| register a simple test function More...
void | registerTest (FIDString name, const char *desc, const TestFuncWithContext &func)
| register a test function with context pointer More...
void | registerTest (FIDString name, const char *desc, TestFuncWithContext &&func)
| register a test function with context pointer More...
void | registerTest (FIDString name, ITest *test)
| register a custom test, the test object will be owned by the implementation More...

## Variables
| kDistributable
| kSimpleModeSupported
| kSample32
| kSample64
| kRealtime
| kPrefetch
| kOffline
| kAudio
| kEvent
| kNumMediaTypes
| kInput
| kOutput
| kMain
| kAux
| kSimple
| kAdvanced
| kOfflineProcessing
| kReloadComponent
| kIoChanged
| kParamValuesChanged
| kLatencyChanged
| kParamTitlesChanged
| kMidiCCAssignmentChanged
| kNoteExpressionChanged
| kIoTitlesChanged
| kPrefetchableSupportChanged
| kRoutingInfoChanged
| kKeyswitchChanged
| kParamIDMappingChanged
| kCircularMode
| kRelativCircularMode
| kLinearMode
| kNoteIDUserRangeLowerBound
| kNoteIDUserRangeUpperBound
| kCtrlBankSelectMSB
| kCtrlModWheel
| kCtrlBreath
| kCtrlFoot
| kCtrlPortaTime
| kCtrlDataEntryMSB
| kCtrlVolume
| kCtrlBalance
| kCtrlPan
| kCtrlExpression
| kCtrlEffect1
| kCtrlEffect2
| kCtrlGPC1
| kCtrlGPC2
| kCtrlGPC3
| kCtrlGPC4
| kCtrlBankSelectLSB
| kCtrlDataEntryLSB
| kCtrlSustainOnOff
| kCtrlPortaOnOff
| kCtrlSustenutoOnOff
| kCtrlSoftPedalOnOff
| kCtrlLegatoFootSwOnOff
| kCtrlHold2OnOff
| kCtrlSoundVariation
| kCtrlFilterCutoff
| kCtrlReleaseTime
| kCtrlAttackTime
| kCtrlFilterResonance
| kCtrlDecayTime
| kCtrlVibratoRate
| kCtrlVibratoDepth
| kCtrlVibratoDelay
| kCtrlSoundCtrler10
| kCtrlGPC5
| kCtrlGPC6
| kCtrlGPC7
| kCtrlGPC8
| kCtrlPortaControl
| kCtrlEff1Depth
| kCtrlEff2Depth
| kCtrlEff3Depth
| kCtrlEff4Depth
| kCtrlEff5Depth
| kCtrlDataIncrement
| kCtrlDataDecrement
| kCtrlNRPNSelectLSB
| kCtrlNRPNSelectMSB
| kCtrlRPNSelectLSB
| kCtrlRPNSelectMSB
| kCtrlAllSoundsOff
| kCtrlResetAllCtrlers
| kCtrlLocalCtrlOnOff
| kCtrlAllNotesOff
| kCtrlOmniModeOff
| kCtrlOmniModeOn
| kCtrlPolyModeOnOff
| kCtrlPolyModeOn
| kAfterTouch
| kPitchBend
| kCountCtrlNumber
| kCtrlProgramChange
| kCtrlPolyPressure
| kCtrlQuarterFrame
| kVolumeTypeID
| kPanTypeID
| kTuningTypeID
| kVibratoTypeID
| kExpressionTypeID
| kBrightnessTypeID
| kTextTypeID
| kPhonemeTypeID
| kCustomStart
| kCustomEnd
| kInvalidTypeID
| kNoteOnKeyswitchTypeID
| kOnTheFlyKeyswitchTypeID
| kOnReleaseKeyswitchTypeID
| kKeyRangeTypeID
| kPUIXMovement
| kPUIYMovement
| kPUIPressure
| kPUITypeCount
| kInvalidPUITypeID
| kIsNeverPrefetchable
| kIsYetPrefetchable
| kIsNotYetPrefetchable
| kNumPrefetchableSupport
const int32 | kDefaultFactoryFlags
const Speaker | kSpeakerL
const Speaker | kSpeakerR
const Speaker | kSpeakerC
const Speaker | kSpeakerLfe
const Speaker | kSpeakerLs
const Speaker | kSpeakerRs
const Speaker | kSpeakerLc
const Speaker | kSpeakerRc
const Speaker | kSpeakerS
const Speaker | kSpeakerCs
const Speaker | kSpeakerSl
const Speaker | kSpeakerSr
const Speaker | kSpeakerTc
const Speaker | kSpeakerTfl
const Speaker | kSpeakerTfc
const Speaker | kSpeakerTfr
const Speaker | kSpeakerTrl
const Speaker | kSpeakerTrc
const Speaker | kSpeakerTrr
const Speaker | kSpeakerLfe2
const Speaker | kSpeakerM
const Speaker | kSpeakerACN0
const Speaker | kSpeakerACN1
const Speaker | kSpeakerACN2
const Speaker | kSpeakerACN3
const Speaker | kSpeakerACN4
const Speaker | kSpeakerACN5
const Speaker | kSpeakerACN6
const Speaker | kSpeakerACN7
const Speaker | kSpeakerACN8
const Speaker | kSpeakerACN9
const Speaker | kSpeakerACN10
const Speaker | kSpeakerACN11
const Speaker | kSpeakerACN12
const Speaker | kSpeakerACN13
const Speaker | kSpeakerACN14
const Speaker | kSpeakerACN15
const Speaker | kSpeakerACN16
const Speaker | kSpeakerACN17
const Speaker | kSpeakerACN18
const Speaker | kSpeakerACN19
const Speaker | kSpeakerACN20
const Speaker | kSpeakerACN21
const Speaker | kSpeakerACN22
const Speaker | kSpeakerACN23
const Speaker | kSpeakerACN24
const Speaker | kSpeakerTsl
const Speaker | kSpeakerTsr
const Speaker | kSpeakerLcs
const Speaker | kSpeakerRcs
const Speaker | kSpeakerBfl
const Speaker | kSpeakerBfc
const Speaker | kSpeakerBfr
const Speaker | kSpeakerPl
const Speaker | kSpeakerPr
const Speaker | kSpeakerBsl
const Speaker | kSpeakerBsr
const Speaker | kSpeakerBrl
const Speaker | kSpeakerBrc
const Speaker | kSpeakerBrr
const Speaker | kSpeakerLw
const Speaker | kSpeakerRw
| IParamValueQueue
IParamValueQueue::iid constexpr int32 | kQueueReservedPoints = 5

## Typedef Documentation

## ◆ ChunkID

using ChunkID = char[4]

## ◆ ProcessSampleSize

using ProcessSampleSize = int32

## ◆ TestFunc

using TestFunc = std::function<bool (ITestResult*)>

simple test function

## ◆ TestFuncWithContext

using TestFuncWithContext = std::function<bool (FUnknown*, ITestResult*)>

test function with context pointer

## Enumeration Type Documentation

## ◆ ChunkType

enum ChunkType

Enumerator
kHeader |
kComponentState |
kControllerState |
kProgramData |
kMetaInfo |
kChunkList |
kNumPresetChunks |

## Function Documentation

## ◆ getChannelBuffersPointer()

void ** Steinberg::Vst::getChannelBuffersPointer | ( | const ProcessSetup & | processSetup,
|  | const AudioBusBuffers & | bufs
| ) |  |
| inline

Returns the current channelBuffers used (depending of symbolicSampleSize).

## ◆ getSampleFramesSizeInBytes()

uint32 Steinberg::Vst::getSampleFramesSizeInBytes | ( | const ProcessSetup & | processSetup,
|  | int32 | numSamples
| ) |  |
| inline

Returns the size in bytes of numSamples for one channel depending of symbolicSampleSize.

## ◆ getChannelMask()

uint64 Steinberg::Vst::getChannelMask | ( | int32 | numChannels | ) |
| inline

return the bit-mask of channels for the given number of channel for example: numChannels = 1 => 0b0001 (binar) = 0x01 = 1 (decimal) numChannels = 2 => 0b0011 (binar) = 0x03 = 3 (decimal) numChannels = 6 => 0b0011 1111 (binar) = 0x3F = 63 (decimal)

## ◆ getSpeakerChannelIndex()

tresult getSpeakerChannelIndex | ( | SpeakerArrangement | arrangement,
|  | uint64 | speaker,
|  | int32 & | channel
| ) |  |

Gets the channel index of a given speaker in a arrangement, returns kResultFalse if speaker not part of the arrangement else returns kResultTrue.

## ◆ setupVSTGUIBundleSupport()

void setupVSTGUIBundleSupport | ( | void * | hInstance | ) |

## ◆ getChunkID()

const ChunkID & getChunkID | ( | ChunkType | type | ) |

## ◆ verify()

bool Steinberg::Vst::verify | ( | tresult | result | ) |
| inline

## ◆ copyStream()

bool Steinberg::Vst::copyStream | ( | IBStream * | inStream,
|  | IBStream * | outStream
| ) |  |

## ◆ IMPLEMENT_FUNKNOWN_METHODS() [1/9]

Steinberg::Vst::IMPLEMENT_FUNKNOWN_METHODS | ( | FileStream | ,
|  | IBStream | ,
|  | IBStream::iid |
| ) |  |

## ◆ IMPLEMENT_REFCOUNT()

Steinberg::Vst::IMPLEMENT_REFCOUNT | ( | ReadOnlyBStream |  | ) |

## ◆ IMPLEMENT_FUNKNOWN_METHODS() [2/9]

Steinberg::Vst::IMPLEMENT_FUNKNOWN_METHODS | ( | BufferStream | ,
|  | IBStream | ,
|  | IBStream::iid |
| ) |  |

## ◆ isEqualID()

bool Steinberg::Vst::isEqualID | ( | const ChunkID | id1,
|  | const ChunkID | id2
| ) |  |
| inline

## ◆ IMPLEMENT_FUNKNOWN_METHODS() [3/9]

Steinberg::Vst::IMPLEMENT_FUNKNOWN_METHODS | ( | ConnectionProxy | ,
|  | IConnectionPoint | ,
|  | IConnectionPoint::iid |
| ) |  |

## ◆ IMPLEMENT_FUNKNOWN_METHODS() [4/9]

Steinberg::Vst::IMPLEMENT_FUNKNOWN_METHODS | ( | EventList | ,
|  | IEventList | ,
|  | IEventList::iid |
| ) |  |

## ◆ IMPLEMENT_FUNKNOWN_METHODS() [5/9]

Steinberg::Vst::IMPLEMENT_FUNKNOWN_METHODS | ( | HostMessage | ,
|  | IMessage | ,
|  | IMessage::iid |
| ) |  |

## ◆ IMPLEMENT_FUNKNOWN_METHODS() [6/9]

Steinberg::Vst::IMPLEMENT_FUNKNOWN_METHODS | ( | HostAttributeList | ,
|  | IAttributeList | ,
|  | IAttributeList::iid |
| ) |  |

## ◆ IMPLEMENT_FUNKNOWN_METHODS() [7/9]

Steinberg::Vst::IMPLEMENT_FUNKNOWN_METHODS | ( | ParameterChanges | ,
|  | IParameterChanges | ,
|  | IParameterChanges::iid |
| ) |  |

## ◆ IMPLEMENT_FUNKNOWN_METHODS() [8/9]

Steinberg::Vst::IMPLEMENT_FUNKNOWN_METHODS | ( | TestBase | ,
|  | ITest | ,
|  | ITest::iid |
| ) |  |

## ◆ addMessage() [1/2]

void addMessage | ( | ITestResult * | testResult,
|  | const std::u16string & | str
| ) |  |

## ◆ addMessage() [2/2]

void addMessage | ( | ITestResult * | testResult,
|  | const char * | str
| ) |  |

## ◆ addErrorMessage() [1/2]

void addErrorMessage | ( | ITestResult * | testResult,
|  | const char * | str
| ) |  |

## ◆ addErrorMessage() [2/2]

void addErrorMessage | ( | ITestResult * | testResult,
|  | const std::u16string & | str
| ) |  |

## ◆ printf()

std::u16string printf | ( | const char8 * | format,
|  |  | ...
| ) |  |

## ◆ IMPLEMENT_FUNKNOWN_METHODS() [9/9]

Steinberg::Vst::IMPLEMENT_FUNKNOWN_METHODS | ( | ParamChanges | ,
|  | IParamValueQueue | ,
|  | IParamValueQueue::iid |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [1/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | PFactoryInfo | ,
|  | 4 | ,
|  | 4 | ,
|  | 4 | ,
|  | 4 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [2/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | PClassInfo2 | ,
|  | 4 | ,
|  | 4 | ,
|  | 4 | ,
|  | 4 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [3/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | ProcessSetup | ,
|  | 8 | ,
|  | 1 | ,
|  | 8 | ,
|  | 8 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [4/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | ProcessData | ,
|  | 8 | ,
|  | 1 | ,
|  | 4 | ,
|  | 4 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [5/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | RoutingInfo | ,
|  | 4 | ,
|  | 1 | ,
|  | 4 | ,
|  | 4 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [6/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | ParameterInfo | ,
|  | 8 | ,
|  | 1 | ,
|  | 8 | ,
|  | 8 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [7/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | NoteOffEvent | ,
|  | 4 | ,
|  | 1 | ,
|  | 4 | ,
|  | 4 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [8/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | PolyPressureEvent | ,
|  | 4 | ,
|  | 1 | ,
|  | 4 | ,
|  | 4 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [9/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | ScaleEvent | ,
|  | 8 | ,
|  | 1 | ,
|  | 4 | ,
|  | 4 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [10/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | Event | ,
|  | 8 | ,
|  | 1 | ,
|  | 8 | ,
|  | 8 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [11/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | NoteExpressionValueEvent | ,
|  | 8 | ,
|  | 1 | ,
|  | 4 | ,
|  | 8 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [12/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | NoteExpressionTypeInfo | ,
|  | 8 | ,
|  | 1 | ,
|  | 8 | ,
|  | 8 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [13/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | FrameRate | ,
|  | 4 | ,
|  | 1 | ,
|  | 4 | ,
|  | 4 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [14/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | ProcessContext | ,
|  | 8 | ,
|  | 1 | ,
|  | 8 | ,
|  | 8 |
| ) |  |

## ◆ SMTG_TYPE_ALIGN_CHECK() [15/15]

Steinberg::Vst::SMTG_TYPE_ALIGN_CHECK | ( | UnitInfo | ,
|  | 4 | ,
|  | 1 | ,
|  | 4 | ,
|  | 4 |
| ) |  |

## ◆ printStructSizes()

void Steinberg::Vst::printStructSizes | ( |  | ) |
| inline

## ◆ aligned_alloc()

void * Steinberg::Vst::aligned_alloc | ( | size_t | numBytes,
|  | uint32_t | alignment
| ) |  |
| inline

aligned allocation

note that you need to use aligned_free to free the block of memory

Parameters

  numBytes | number of bytes to allocate
  alignment | alignment of memory base address. must be a power of 2 and at least as large as sizeof (void*) or zero in which it uses malloc for allocation

Returns
  allocated memory

## ◆ aligned_free()

void Steinberg::Vst::aligned_free | ( | void * | addr,
|  | uint32_t | alignment
| ) |  |
| inline

## ◆ getChannelBuffers() [1/2]

Sample32 ** Steinberg::Vst::getChannelBuffers | ( | AudioBusBuffers & | buffer | ) |
| inline

get channel buffers from audio bus buffers 32 bit variant

## ◆ getChannelBuffers() [2/2]

Sample64 ** Steinberg::Vst::getChannelBuffers | ( | AudioBusBuffers & | buffer | ) |
| inline

get channel buffers from audio bus buffers 64 bit variant

## ◆ operator==() [1/2]

bool Steinberg::Vst::operator== | ( | const DataExchangeHandler::Config & | c1,
|  | const DataExchangeHandler::Config & | c2
| ) |  |

## ◆ operator!=()

bool Steinberg::Vst::operator!= | ( | const DataExchangeBlock & | lhs,
|  | const DataExchangeBlock & | rhs
| ) |  |
| inline

## ◆ operator==() [2/2]

bool Steinberg::Vst::operator== | ( | const DataExchangeBlock & | lhs,
|  | const DataExchangeBlock & | rhs
| ) |  |
| inline

## ◆ toTChar()

const Steinberg::Vst::TChar * Steinberg::Vst::toTChar | ( | const std::u16string & | str | ) |
| inline

## ◆ toString()

std::u16string Steinberg::Vst::toString | ( | NumberT | value | ) |

convert a number to an UTF-16 string

Parameters

  value | number

Returns
  UTF-16 string

## ◆ createTestFactoryInstance()

FUnknown * Steinberg::Vst::createTestFactoryInstance | ( | void * |  | ) |

create a Test Factory instance

## ◆ getTestFactoryUID()

const FUID & Steinberg::Vst::getTestFactoryUID | ( |  | ) |

get the test factory class ID

## ◆ registerTest() [1/5]

void Steinberg::Vst::registerTest | ( | FIDString | name,
|  | const char * | desc,
|  | const TestFunc & | func
| ) |  |

register a simple test function

## ◆ registerTest() [2/5]

void Steinberg::Vst::registerTest | ( | FIDString | name,
|  | const char * | desc,
|  | TestFunc && | func
| ) |  |

register a simple test function

## ◆ registerTest() [3/5]

void Steinberg::Vst::registerTest | ( | FIDString | name,
|  | const char * | desc,
|  | const TestFuncWithContext & | func
| ) |  |

register a test function with context pointer

## ◆ registerTest() [4/5]

void Steinberg::Vst::registerTest | ( | FIDString | name,
|  | const char * | desc,
|  | TestFuncWithContext && | func
| ) |  |

register a test function with context pointer

## ◆ registerTest() [5/5]

void Steinberg::Vst::registerTest | ( | FIDString | name,
|  | ITest * | test
| ) |  |

register a custom test, the test object will be owned by the implementation

## Variable Documentation

## ◆ IParamValueQueue

IParamValueQueue

## ◆ kQueueReservedPoints

IParamValueQueue::iid constexpr int32 kQueueReservedPoints = 5
| constexpr

Empty

Copyright © Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.